r25299: Modify the provision script to take an additional argument: --server-role
[samba.git] / source4 / selftest / env / Samba4.pm
1 #!/usr/bin/perl
2 # Bootstrap Samba and run a number of tests against it.
3 # Copyright (C) 2005-2007 Jelmer Vernooij <jelmer@samba.org>
4 # Published under the GNU GPL, v3 or later.
5
6 package Samba4;
7
8 use strict;
9 use Cwd qw(abs_path);
10 use FindBin qw($RealBin);
11 use POSIX;
12
13 sub new($$$$) {
14         my ($classname, $bindir, $ldap, $setupdir) = @_;
15         my $self = { 
16                 vars => {}, 
17                 ldap => $ldap, 
18                 bindir => $bindir, 
19                 setupdir => $setupdir 
20         };
21         bless $self;
22         return $self;
23 }
24
25 sub openldap_start($$$) {
26         my ($slapd_conf, $uri, $logs) = @_;
27         my $oldpath = $ENV{PATH};
28         $ENV{PATH} = "/usr/local/sbin:/usr/sbin:/sbin:$ENV{PATH}";
29         system("slapd -d0 -f $slapd_conf -h $uri > $logs 2>&1 &");
30         $ENV{PATH} = $oldpath;
31 }
32
33 sub slapd_start($$)
34 {
35         my $count = 0;
36         my ($self, $env_vars) = @_;
37
38         my $uri = $env_vars->{LDAP_URI};
39
40         # running slapd in the background means it stays in the same process group, so it can be
41         # killed by timelimit
42         if ($self->{ldap} eq "fedora-ds") {
43                 system("$ENV{FEDORA_DS_PREFIX}/sbin/ns-slapd -D $env_vars->{FEDORA_DS_DIR} -d0 -i $env_vars->{FEDORA_DS_PIDFILE}> $env_vars->{LDAPDIR}/logs 2>&1 &");
44         } elsif ($self->{ldap} eq "openldap") {
45                 openldap_start($env_vars->{SLAPD_CONF}, $uri, "$env_vars->{LDAPDIR}/logs");
46         }
47         while (system("$self->{bindir}/ldbsearch -H $uri -s base -b \"\" supportedLDAPVersion > /dev/null") != 0) {
48                 $count++;
49                 if ($count > 40) {
50                     $self->slapd_stop($env_vars);
51                     return 0;
52                 }
53                 sleep(1);
54         }
55         return 1;
56 }
57
58 sub slapd_stop($$)
59 {
60         my ($self, $envvars) = @_;
61         if ($self->{ldap} eq "fedora-ds") {
62                 system("$envvars->{LDAPDIR}/slapd-samba4/stop-slapd");
63         } elsif ($self->{ldap} eq "openldap") {
64                 open(IN, "<$envvars->{OPENLDAP_PIDFILE}") or 
65                         die("unable to open slapd pid file: $envvars->{OPENLDAP_PIDFILE}");
66                 kill 9, <IN>;
67                 close(IN);
68         }
69         return 1;
70 }
71
72 sub check_or_start($$$) 
73 {
74         my ($self, $env_vars, $max_time) = @_;
75         return 0 if ( -p $env_vars->{SMBD_TEST_FIFO});
76
77         unlink($env_vars->{SMBD_TEST_FIFO});
78         POSIX::mkfifo($env_vars->{SMBD_TEST_FIFO}, 0700);
79         unlink($env_vars->{SMBD_TEST_LOG});
80         
81         print "STARTING SMBD... ";
82         my $pid = fork();
83         if ($pid == 0) {
84                 open STDIN, $env_vars->{SMBD_TEST_FIFO};
85                 open STDOUT, ">$env_vars->{SMBD_TEST_LOG}";
86                 open STDERR, '>&STDOUT';
87                 
88                 SocketWrapper::set_default_iface($env_vars->{SOCKET_WRAPPER_DEFAULT_IFACE});
89
90                 my $valgrind = "";
91                 if (defined($ENV{SMBD_VALGRIND})) {
92                     $valgrind = $ENV{SMBD_VALGRIND};
93                 } 
94
95                 $ENV{KRB5_CONFIG} = $env_vars->{KRB5_CONFIG}; 
96
97                 # Start slapd before smbd, but with the fifo on stdin
98                 if (defined($self->{ldap})) {
99                     $self->slapd_start($env_vars) or 
100                         die("couldn't start slapd (2nd time)");
101                 }
102
103                 my $optarg = "";
104                 if (defined($max_time)) {
105                         $optarg = "--maximum-runtime=$max_time ";
106                 }
107                 my $ret = system("$valgrind $self->{bindir}/smbd $optarg $env_vars->{CONFIGURATION} -M single -i --leak-report-full");
108                 if ($? == -1) {
109                         print "Unable to start smbd: $ret: $!\n";
110                         exit 1;
111                 }
112                 unlink($env_vars->{SMBD_TEST_FIFO});
113                 my $exit = $? >> 8;
114                 if ( $ret == 0 ) {
115                         print "smbd exits with status $exit\n";
116                 } elsif ( $ret & 127 ) {
117                         print "smbd got signal ".($ret & 127)." and exits with $exit!\n";
118                 } else {
119                         $ret = $? >> 8;
120                         print "smbd failed with status $exit!\n";
121                 }
122                 exit $exit;
123         }
124         print "DONE\n";
125
126         open(DATA, ">$env_vars->{SMBD_TEST_FIFO}");
127
128         return $pid;
129 }
130
131 sub wait_for_start($$)
132 {
133         my ($self, $testenv_vars) = @_;
134         # give time for nbt server to register its names
135         print "delaying for nbt name registration\n";
136         sleep 2;
137
138         # This will return quickly when things are up, but be slow if we 
139         # need to wait for (eg) SSL init 
140         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{SERVER}");
141         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{SERVER}");
142         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSNAME}");
143         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSNAME}");
144         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSALIAS}");
145         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSALIAS}");
146         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{SERVER}");
147         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{SERVER}");
148         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSNAME}");
149         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSNAME}");
150         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSALIAS}");
151         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSALIAS}");
152
153         print $self->getlog_env($testenv_vars);
154 }
155
156 sub write_ldb_file($$$)
157 {
158         my ($self, $file, $ldif) = @_;
159
160         open(LDIF, "|$self->{bindir}/ldbadd -H $file >/dev/null");
161         print LDIF $ldif;
162         return close(LDIF);
163 }
164
165 sub add_wins_config($$)
166 {
167         my ($self, $privatedir) = @_;
168
169         return $self->write_ldb_file("$privatedir/wins_config.ldb", "
170 dn: name=TORTURE_6,CN=PARTNERS
171 objectClass: wreplPartner
172 name: TORTURE_6
173 address: 127.0.0.6
174 pullInterval: 0
175 pushChangeCount: 0
176 type: 0x3
177 ");
178 }
179
180 sub mk_fedora_ds($$$)
181 {
182         my ($self, $ldapdir, $configuration) = @_;
183
184         my $fedora_ds_inf = "$ldapdir/fedorads.inf";
185         my $fedora_ds_extra_ldif = "$ldapdir/fedorads-partitions.ldif";
186
187         #Make the subdirectory be as fedora DS would expect
188         my $fedora_ds_dir = "$ldapdir/slapd-samba4";
189
190         my $pidfile = "$fedora_ds_dir/logs/slapd-samba4.pid";
191
192 my $dir = getcwd();
193 chdir "$ENV{FEDORA_DS_PREFIX}/bin" || die;
194         if (system("perl $ENV{FEDORA_DS_PREFIX}/bin/ds_newinst.pl $fedora_ds_inf >&2") != 0) {
195             chdir $dir;
196             die("perl $ENV{FEDORA_DS_PREFIX}/bin/ds_newinst.pl $fedora_ds_inf FAILED: $?");
197         }
198         chdir $dir || die;
199
200         system("cat $fedora_ds_extra_ldif >> $fedora_ds_dir/dse.ldif");
201
202         system("$self->{bindir}/ad2oLschema $configuration -H $ldapdir/schema-tmp.ldb --option=convert:target=fedora-ds -I $self->{setupdir}/schema-map-fedora-ds-1.0 -O $fedora_ds_dir/schema/99_ad.ldif >&2") == 0 or die("schema conversion for Fedora DS failed");
203
204         return ($fedora_ds_dir, $pidfile);
205 }
206
207 sub mk_openldap($$$)
208 {
209         my ($self, $ldapdir, $configuration) = @_;
210
211         my $slapd_conf = "$ldapdir/slapd.conf";
212         my $pidfile = "$ldapdir/slapd.pid";
213         my $modconf = "$ldapdir/modules.conf";
214
215         #This uses the backend provision we just did, to read out the schema
216         system("$self->{bindir}/ad2oLschema $configuration --option=convert:target=openldap -H $ldapdir/schema-tmp.ldb -I $self->{setupdir}/schema-map-openldap-2.3 -O $ldapdir/backend-schema.schema >&2") == 0 or die("schema conversion for OpenLDAP failed");
217
218         my $oldpath = $ENV{PATH};
219         $ENV{PATH} = "/usr/local/sbin:/usr/sbin:/sbin:$ENV{PATH}";
220
221         unlink($modconf);
222         open(CONF, ">$modconf"); close(CONF);
223
224         if (system("slaptest -u -f $slapd_conf >&2") != 0) {
225                 open(CONF, ">$modconf"); 
226                 # enable slapd modules
227                 print CONF "
228 modulepath      /usr/lib/ldap
229 moduleload      back_bdb
230 moduleload      syncprov
231 ";
232                 close(CONF);
233         }
234
235         if (system("slaptest -u -f $slapd_conf >&2") != 0) {
236                 open(CONF, ">$modconf"); 
237                 # enable slapd modules (Fedora layout)
238                 print CONF "
239 modulepath      /usr/lib/openldap
240 moduleload      syncprov
241 ";
242                 close(CONF);
243         }
244
245         if (system("slaptest -u -f $slapd_conf >&2") != 0) {
246                 open(CONF, ">$modconf"); 
247                 # enable slapd modules (Fedora x86_64 layout)
248                 print CONF "
249 modulepath      /usr/lib64/openldap
250 moduleload      syncprov
251 ";
252                 close(CONF);
253         }
254
255         system("slaptest -u -f $slapd_conf") == 0 or die("slaptest still fails after adding modules");
256
257     
258         $ENV{PATH} = $oldpath;
259
260         return ($slapd_conf, $pidfile);
261 }
262
263 sub provision($$$$$$)
264 {
265         my ($self, $prefix, $server_role, $netbiosname, $netbiosalias, $swiface, $password) = @_;
266
267         my $smbd_loglevel = 1;
268         my $username = "administrator";
269         my $domain = "SAMBADOMAIN";
270         my $realm = "SAMBA.EXAMPLE.COM";
271         my $dnsname = "samba.example.com";
272         my $basedn = "dc=samba,dc=example,dc=com";
273         my $root = ($ENV{USER} or $ENV{LOGNAME} or `whoami`);
274         my $srcdir="$RealBin/..";
275         -d $prefix or mkdir($prefix, 0777) or die("Unable to create $prefix");
276         my $prefix_abs = abs_path($prefix);
277         my $tmpdir = "$prefix_abs/tmp";
278         my $etcdir = "$prefix_abs/etc";
279         my $piddir = "$prefix_abs/pid";
280         my $conffile = "$etcdir/smb.conf";
281         my $krb5_config = "$etcdir/krb5.conf";
282         my $privatedir = "$prefix_abs/private";
283         my $ncalrpcdir = "$prefix_abs/ncalrpc";
284         my $lockdir = "$prefix_abs/lockdir";
285         my $winbindd_socket_dir = "$prefix_abs/winbind_socket";
286
287         my $configuration = "--configfile=$conffile";
288         my $ldapdir = "$privatedir/ldap";
289
290         my $tlsdir = "$privatedir/tls";
291
292         my $ifaceipv4 = "127.0.0.$swiface";
293         my $interfaces = "$ifaceipv4/8";
294
295         (system("rm -rf $prefix/*") == 0) or die("Unable to clean up");
296         mkdir($_, 0777) foreach ($privatedir, $etcdir, $piddir, $ncalrpcdir, $lockdir, 
297                 $tmpdir);
298
299
300         my $localbasedn = $basedn;
301         $localbasedn = "DC=$netbiosname" if $server_role eq "member server";
302
303         open(CONFFILE, ">$conffile");
304         print CONFFILE "
305 [global]
306         netbios name = $netbiosname
307         netbios aliases = $netbiosalias
308         workgroup = $domain
309         realm = $realm
310         private dir = $privatedir
311         pid directory = $piddir
312         ncalrpc dir = $ncalrpcdir
313         lock dir = $lockdir
314         setup directory = $self->{setupdir}
315         js include = $srcdir/scripting/libjs
316         winbindd socket directory = $winbindd_socket_dir
317         winbind separator = /
318         name resolve order = bcast
319         interfaces = $interfaces
320         tls dh params file = $tlsdir/dhparms.pem
321         panic action = $srcdir/script/gdb_backtrace \%PID% \%PROG%
322         wins support = yes
323         server role = $server_role
324         max xmit = 32K
325         server max protocol = SMB2
326         notify:inotify = false
327         ldb:nosync = true
328         system:anonymous = true
329 #We don't want to pass our self-tests if the PAC code is wrong
330         gensec:require_pac = true
331         log level = $smbd_loglevel
332
333 [tmp]
334         path = $tmpdir
335         read only = no
336         ntvfs handler = posix
337         posix:sharedelay = 100000
338         posix:eadb = $lockdir/eadb.tdb
339
340 [cifs]
341         read only = no
342         ntvfs handler = cifs
343         cifs:server = $netbiosname
344         cifs:share = tmp
345 #There is no username specified here, instead the client is expected
346 #to log in with kerberos, and smbd will used delegated credentials.
347
348 [simple]
349         path = $tmpdir
350         read only = no
351         ntvfs handler = simple
352
353 [cifsposix]
354         copy = simple
355         ntvfs handler = cifsposix   
356 ";
357         close(CONFFILE);
358
359         die ("Unable to create key blobs") if
360                 (system("TLSDIR=$tlsdir $RealBin/mk-keyblobs.sh") != 0);
361
362         open(KRB5CONF, ">$krb5_config");
363         print KRB5CONF "
364 #Generated krb5.conf for $realm
365
366 [libdefaults]
367  default_realm = $realm
368  dns_lookup_realm = false
369  dns_lookup_kdc = false
370  ticket_lifetime = 24h
371  forwardable = yes
372
373 [realms]
374  $realm = {
375   kdc = 127.0.0.1:88
376   admin_server = 127.0.0.1:88
377   default_domain = $dnsname
378  }
379  $dnsname = {
380   kdc = 127.0.0.1:88
381   admin_server = 127.0.0.1:88
382   default_domain = $dnsname
383  }
384  $domain = {
385   kdc = 127.0.0.1:88
386   admin_server = 127.0.0.1:88
387   default_domain = $dnsname
388  }
389
390 [appdefaults]
391         pkinit_anchors = FILE:$tlsdir/ca.pem
392
393 [kdc]
394         enable-pkinit = true
395         pkinit_identity = FILE:$tlsdir/kdc.pem,$tlsdir/key.pem
396         pkinit_anchors = FILE:$tlsdir/ca.pem
397
398 [domain_realm]
399  .$dnsname = $realm
400 ";
401         close(KRB5CONF);
402
403 #Ensure the config file is valid before we start
404         if (system("$self->{bindir}/testparm $configuration -v --suppress-prompt >/dev/null 2>&1") != 0) {
405                 system("$self->{bindir}/testparm -v --suppress-prompt $configuration >&2");
406                 die("Failed to create a valid smb.conf configuration!");
407         }
408
409         (system("($self->{bindir}/testparm $configuration -v --suppress-prompt --parameter-name=\"netbios name\" --section-name=global 2> /dev/null | grep -i \"^$netbiosname\" ) >/dev/null 2>&1") == 0) or die("Failed to create a valid smb.conf configuration!");
410
411 my @provision_options = ("$self->{bindir}/smbscript", "$self->{setupdir}/provision");
412         push (@provision_options, split(' ', $configuration));
413         push (@provision_options, "--host-name=$netbiosname");
414         push (@provision_options, "--host-ip=$ifaceipv4");
415 #       push (@provision_options, "--quiet");
416         push (@provision_options, "--domain=$domain");
417         push (@provision_options, "--realm=$realm");
418         push (@provision_options, "--adminpass=$password");
419         push (@provision_options, "--krbtgtpass=krbtgt$password");
420         push (@provision_options, "--machinepass=machine$password");
421         push (@provision_options, "--root=$root");
422         push (@provision_options, "--simple-bind-dn=cn=Manager,$localbasedn");
423         push (@provision_options, "--password=$password");
424         push (@provision_options, "--root=$root");
425         push (@provision_options, "--server-role=$server_role");
426
427         my $ldap_uri= "$ldapdir/ldapi";
428         $ldap_uri =~ s|/|%2F|g;
429         $ldap_uri = "ldapi://$ldap_uri";
430
431         my $ret = {
432                 KRB5_CONFIG => $krb5_config,
433                 PIDDIR => $piddir,
434                 SERVER => $netbiosname,
435                 SERVER_IP => $ifaceipv4,
436                 NETBIOSNAME => $netbiosname,
437                 NETBIOSALIAS => $netbiosalias,
438                 LDAP_URI => $ldap_uri,
439                 DOMAIN => $domain,
440                 USERNAME => $username,
441                 REALM => $realm,
442                 PASSWORD => $password,
443                 LDAPDIR => $ldapdir,
444                 WINBINDD_SOCKET_DIR => $winbindd_socket_dir,
445                 NCALRPCDIR => $ncalrpcdir,
446                 LOCKDIR => $lockdir,
447                 CONFIGURATION => $configuration,
448                 SOCKET_WRAPPER_DEFAULT_IFACE => $swiface
449         };
450
451         if (defined($self->{ldap})) {
452
453                 push (@provision_options, "--ldap-backend=$ldap_uri");
454                 system("$self->{bindir}/smbscript $self->{setupdir}/provision-backend $configuration --ldap-manager-pass=$password --root=$root --realm=$realm --host-name=$netbiosname --ldap-backend-type=$self->{ldap}>&2") == 0 or die("backend provision failed");
455
456                 if ($self->{ldap} eq "openldap") {
457                        ($ret->{SLAPD_CONF}, $ret->{OPENLDAP_PIDFILE}) = $self->mk_openldap($ldapdir, $configuration) or die("Unable to create openldap directories");
458                 } elsif ($self->{ldap} eq "fedora-ds") {
459                        ($ret->{FEDORA_DS_DIR}, $ret->{FEDORA_DS_PIDFILE}) = $self->mk_fedora_ds($ldapdir, $configuration) or die("Unable to create fedora ds directories");
460                        push (@provision_options, "--ldap-module=nsuniqueid");
461                        push (@provision_options, "--aci=aci:: KHRhcmdldGF0dHIgPSAiKiIpICh2ZXJzaW9uIDMuMDthY2wgImZ1bGwgYWNjZXNzIHRvIGFsbCBieSBhbGwiO2FsbG93IChhbGwpKHVzZXJkbiA9ICJsZGFwOi8vL2FueW9uZSIpOykK");
462                  }
463
464                 $self->slapd_start($ret) or 
465                         die("couldn't start slapd");
466         }
467
468         (system(@provision_options) == 0) or die("Unable to provision");
469
470         if (defined($self->{ldap})) {
471                 $self->slapd_stop($ret) or 
472                         die("couldn't stop slapd");
473         }
474
475         return $ret; 
476 }
477
478 sub provision_member($$$)
479 {
480         my ($self, $prefix, $dcvars) = @_;
481         print "PROVISIONING MEMBER...";
482
483         my $ret = $self->provision($prefix,
484                                    "member server",
485                                    "localmember3",
486                                    "localmember",
487                                    3,
488                                    "localmemberpass");
489
490         $ret or die("Unable to provision");
491
492         my $cmd = "";
493         $cmd .= "SOCKET_WRAPPER_DEFAULT_IFACE=\"$ret->{SOCKET_WRAPPER_DEFAULT_IFACE}\" ";
494         $cmd .= "KRB5_CONFIG=\"$ret->{KRB5_CONFIG}\" ";
495         $cmd .= "$self->{bindir}/net join $ret->{CONFIGURATION} $dcvars->{DOMAIN} member";
496         $cmd .= " -U$dcvars->{USERNAME}\%$dcvars->{PASSWORD}";
497
498         system($cmd) == 0 or die("Join failed\n$cmd");
499
500         $ret->{SMBD_TEST_FIFO} = "$prefix/smbd_test.fifo";
501         $ret->{SMBD_TEST_LOG} = "$prefix/smbd_test.log";
502         $ret->{SMBD_TEST_LOG_POS} = 0;
503
504         $ret->{DC_SERVER} = $dcvars->{SERVER};
505         $ret->{DC_SERVER_IP} = $dcvars->{SERVER_IP};
506         $ret->{DC_NETBIOSNAME} = $dcvars->{NETBIOSNAME};
507         $ret->{DC_NETBIOSALIAS} = $dcvars->{NETBIOSALIAS};
508         $ret->{DC_USERNAME} = $dcvars->{USERNAME};
509         $ret->{DC_PASSWORD} = $dcvars->{PASSWORD};
510
511         return $ret;
512 }
513
514 sub provision_dc($$)
515 {
516         my ($self, $prefix) = @_;
517
518         print "PROVISIONING DC...";
519         my $ret = $self->provision($prefix,
520                                    "domain controller",
521                                    "localdc1",
522                                    "localdc",
523                                    1,
524                                    "localdcpass");
525
526         $self->add_wins_config("$prefix/private") or 
527                 die("Unable to add wins configuration");
528
529         $ret->{SMBD_TEST_FIFO} = "$prefix/smbd_test.fifo";
530         $ret->{SMBD_TEST_LOG} = "$prefix/smbd_test.log";
531         $ret->{SMBD_TEST_LOG_POS} = 0;
532         return $ret;
533 }
534
535 sub teardown_env($$)
536 {
537         my ($self, $envvars) = @_;
538         my $pid;
539
540         close(DATA);
541
542         if (-f "$envvars->{PIDDIR}/smbd.pid" ) {
543                 open(IN, "<$envvars->{PIDDIR}/smbd.pid") or die("unable to open smbd pid file");
544                 $pid = <IN>;
545                 close(IN);
546
547                 # Give the process 20 seconds to exit.  gcov needs
548                 # this time to write out the covarge data
549                 my $count = 0;
550                 until (kill(0, $pid) == 0) {
551                     # if no process sucessfully signalled, then we are done
552                     sleep(1);
553                     $count++;
554                     last if $count > 20;
555                 }
556                 
557                 # If it is still around, kill it
558                 if ($count > 20) {
559                     print "smbd process $pid took more than $count seconds to exit, killing\n";
560                     kill 9, $pid;
561                 }
562         }
563
564         my $failed = $? >> 8;
565
566         $self->slapd_stop($envvars) if ($self->{ldap});
567
568         print $self->getlog_env($envvars);
569
570         return $failed;
571 }
572
573 sub getlog_env($$)
574 {
575         my ($self, $envvars) = @_;
576         my $title = "SMBD LOG of: $envvars->{NETBIOSNAME}\n";
577         my $out = $title;
578
579         open(LOG, "<$envvars->{SMBD_TEST_LOG}");
580
581         seek(LOG, $envvars->{SMBD_TEST_LOG_POS}, SEEK_SET);
582         while (<LOG>) {
583                 $out .= $_;
584         }
585         $envvars->{SMBD_TEST_LOG_POS} = tell(LOG);
586         close(LOG);
587
588         return "" if $out eq $title;
589  
590         return $out;
591 }
592
593 sub check_env($$)
594 {
595         my ($self, $envvars) = @_;
596
597         return 1 if (-p $envvars->{SMBD_TEST_FIFO});
598
599         print $self->getlog_env($envvars);
600
601         return 0;
602 }
603
604 sub setup_env($$$)
605 {
606         my ($self, $envname, $path) = @_;
607
608         if ($envname eq "dc") {
609                 return $self->setup_dc("$path/dc");
610         } elsif ($envname eq "member") {
611                 if (not defined($self->{vars}->{dc})) {
612                         $self->setup_dc("$path/dc");
613                 }
614                 return $self->setup_member("$path/member", $self->{vars}->{dc});
615         } else {
616                 die("Samba4 can't provide environment '$envname'");
617         }
618 }
619
620 sub setup_member($$$$)
621 {
622         my ($self, $path, $dc_vars) = @_;
623
624         my $env = $self->provision_member($path, $dc_vars);
625
626         $self->check_or_start($env, ($ENV{SMBD_MAXTIME} or 7500));
627
628         $self->wait_for_start($env);
629
630         return $env;
631 }
632
633 sub setup_dc($$)
634 {
635         my ($self, $path) = @_;
636
637         my $env = $self->provision_dc($path);
638
639         $self->check_or_start($env, 
640                 ($ENV{SMBD_MAXTIME} or 7500));
641
642         $self->wait_for_start($env);
643
644         $self->{vars}->{dc} = $env;
645
646         return $env;
647 }
648
649 sub stop($)
650 {
651         my ($self) = @_;
652 }
653
654 1;